<?php
/**
 * Clase Base FN para BaseCrEventoLogFN
 *
 * @package    
 * @subpackage BaseCrEventoLogFN
 * @author     Willy
 * @version    SVN:: BaseCrEventoLogFN.class.php,v 1.1 2023-02-22 18:07:17 william.taype Exp $
 */
class BaseCrEventoLogFN extends CrEventoLogBN
{
  private static $fieldNames = array (
    'IdEventoLog'=>'IdEventoLog', 'IdEventoTipo'=>'IdEventoTipo', 'Fecha'=>'Fecha', 'Descripcion'=>'Fecha', 'DescripcionEventoTipo'=>'DescripcionEventoTipo', 'ClavePrimaria'=>'NombreClavePrimaria', 'ValorClavePrimaria'=>'ValorClavePrimaria', 'ValorAnterior'=>'ValorAnterior', 'ValorActual'=>'ValorActual', 'UsuarioCreacion'=>'UsuarioCreacion', 'FechaCreacion'=>'FechaCreacion'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT IdEventoLog, IdEventoTipo, Fecha, Fecha, DescripcionEventoTipo, NombreClavePrimaria, ValorClavePrimaria, ValorAnterior, ValorActual, UsuarioCreacion, FechaCreacion FROM cr_evento_log WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT IdEventoLog, IdEventoTipo, Fecha, Fecha, DescripcionEventoTipo, NombreClavePrimaria, ValorClavePrimaria, ValorAnterior, ValorActual, UsuarioCreacion, FechaCreacion FROM cr_evento_log WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdEventoLog()){ $where .= " AND ideventolog = '".$this->getIdEventoLog()."'"; }
      if($this->getIdEventoTipo()){ $where .= " AND ideventotipo = '".$this->getIdEventoTipo()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      if($this->getDescripcion()){ $where .= " AND fecha = '".$this->getDescripcion()."'"; }
      if($this->getDescripcionEventoTipo()){ $where .= " AND descripcioneventotipo = '".$this->getDescripcionEventoTipo()."'"; }
      if($this->getClavePrimaria()){ $where .= " AND nombreclaveprimaria = '".$this->getClavePrimaria()."'"; }
      if($this->getValorClavePrimaria()){ $where .= " AND valorclaveprimaria = '".$this->getValorClavePrimaria()."'"; }
      if($this->getValorAnterior()){ $where .= " AND valoranterior = '".$this->getValorAnterior()."'"; }
      if($this->getValorActual()){ $where .= " AND valoractual = '".$this->getValorActual()."'"; }
      if($this->getUsuarioCreacion()){ $where .= " AND usuariocreacion = '".$this->getUsuarioCreacion()."'"; }
      if($this->getFechaCreacion()){ $where .= " AND fechacreacion = '".$this->getFechaCreacion()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Búsqueda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdEventoLog, IdEventoTipo, Fecha, Fecha, DescripcionEventoTipo, NombreClavePrimaria, ValorClavePrimaria, ValorAnterior, ValorActual, UsuarioCreacion, FechaCreacion FROM cr_evento_log WHERE 1 AND IdEventoLog='".$this->getIdEventoLog()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrEventoLogFN = new BaseCrEventoLogFN();
    $o_BaseCrEventoLogFN->setIdEventoLog($o_propel->IdEventoLog);
    $o_BaseCrEventoLogFN->setIdEventoTipo($o_propel->IdEventoTipo);
    $o_BaseCrEventoLogFN->setFecha($o_propel->Fecha);
    $o_BaseCrEventoLogFN->setDescripcion($o_propel->Fecha);
    $o_BaseCrEventoLogFN->setDescripcionEventoTipo($o_propel->DescripcionEventoTipo);
    $o_BaseCrEventoLogFN->setClavePrimaria($o_propel->NombreClavePrimaria);
    $o_BaseCrEventoLogFN->setValorClavePrimaria($o_propel->ValorClavePrimaria);
    $o_BaseCrEventoLogFN->setValorAnterior($o_propel->ValorAnterior);
    $o_BaseCrEventoLogFN->setValorActual($o_propel->ValorActual);
    $o_BaseCrEventoLogFN->setUsuarioCreacion($o_propel->UsuarioCreacion);
    $o_BaseCrEventoLogFN->setFechaCreacion($o_propel->FechaCreacion);
    return $o_BaseCrEventoLogFN;
  }
}